Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util
Class Properties

    java.lang.Object
      |
      +--java.util.Dictionary
            |
            +--java.util.Hashtable
                  |
                  +--java.util.Properties

All Implemented Interfaces:
  Cloneable, Map, Serializable

Direct Known Subclasses:
  Provider

public class Properties
extends Hashtable

The `Properties` class represents a persistent set of properties. The `Properties` can be saved to a stream or loaded from a stream. Each key and its corresponding value in the property list is a string.

A property list can contain another property list as its "defaults"; this second property list is searched if the property key is not found in the original property list.

Because `Properties` inherits from `Hashtable`, the `put` and `putAll` methods can be applied to a `Properties` object. Their use is strongly discouraged as they allow the caller to insert entries whose keys or values are not `Strings`. The `setProperty` method should be used instead. If the `store` or `save` method is called on a "compromised" `Properties` object that contains a non-`String` key or value, the call will fail.

When saving properties to a stream or loading them from a stream, the ISO 8859-1 character encoding is used. For characters that cannot be directly represented in this encoding, Unicode escapes are used; however, only a single 'u' character is allowed in an escape sequence. The native2ascii tool can be used to convert property files to and from other character encodings.

Since:
  JDK1.0
See Also:
  native2ascii tool for Solaris, native2ascii tool for Windows, Serialized Form

Inner classes inherited from class java.util.Map
`Map.Entry`

Field Summary
`protected Properties` | `defaults` A property list that contains default values for any keys not found in this property list.

Constructor Summary
`Properties()` Creates an empty property list with no default values.
`Properties(Properties defaults)` Creates an empty property list with the specified defaults.

Method Summary
`String` | `getProperty(String key)` Searches for the property with the specified key in this property list.
`String` | `getProperty(String key, String defaultValue)` Searches for the property with the specified key in this property list.
`void` | `list(PrintStream out)` Prints this property list out to the specified output stream.
`void` | `list(PrintWriter out)` Prints this property list out to the specified output stream.
`void` | `load(InputStream inStream)` Reads a property list (key and element pairs) from the input stream.
`Enumeration` | `propertyNames()` Returns an enumeration of all the keys in this property list, including the keys in the default property list.
`void` | `save(OutputStream out, String header)` Deprecated. This method does not throw an IOException if an I/O error occurs while saving the property list. As of the Java 2 platform v1.2, the preferred way to save a properties list is via the `store(OutputStream out, String header)` method.
`Object` | `setProperty(String key, String value)` Calls the hashtable method `put`.
`void` | `store(OutputStream out, String header)` Writes this property list (key and element pairs) in this `Properties` table to the output stream in a format suitable for loading into a `Properties` table using the `load` method.

Methods inherited from class java.util.Hashtable
`clear, clone, contains, containsKey, containsValue, elements, entrySet, equals, get, hashCode, isEmpty, keys, keySet, put, putAll, rehash, remove, size, toString, values`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### defaults

    protected Properties defaults

  A property list that contains default values for any keys not found in this property list.

Constructor Detail

### Properties

    public Properties()

  Creates an empty property list with no default values.

### Properties

    public Properties(Properties defaults)

  Creates an empty property list with the specified defaults.
  Parameters:
    `defaults` - the defaults.

Method Detail

### setProperty

    public Object setProperty(String key,
                              String value)

  Calls the hashtable method `put`. Provided for parallelism with the `getProperty` method. Enforces use of strings for property keys and values.
  Parameters:
    `key` - the key to be placed into this property list.
    `value` - the value corresponding to `key`.
  Since:
    1.2
  See Also:
    `getProperty(java.lang.String)`

### load

    public void load(InputStream inStream)
              throws IOException

  Reads a property list (key and element pairs) from the input stream. The stream is assumed to be using the ISO 8859-1 character encoding.

  Every property occupies one line of the input stream. Each line is terminated by a line terminator (`\n` or `\r` or `\r\n`). Lines from the input stream are processed until end of file is reached on the input stream.

  A line that contains only whitespace or whose first non-whitespace character is an ASCII `#` or `!` is ignored (thus, `#` or `!` indicate comment lines).

  Every line other than a blank line or a comment line describes one property to be added to the table (except that if a line ends with \, then the following line, if it exists, is treated as a continuation line, as described below). The key consists of all the characters in the line starting with the first non-whitespace character and up to, but not including, the first ASCII `=`, `:`, or whitespace character. All of the key termination characters may be included in the key by preceding them with a \. Any whitespace after the key is skipped; if the first non-whitespace character after the key is `=` or `:`, then it is ignored and any whitespace characters after it are also skipped. All remaining characters on the line become part of the associated element string. Within the element string, the ASCII escape sequences `\t`, `\n`, `\r`, `\\`, `\"`, `\'`, `\` (a backslash and a space), and `\u` xxxx are recognized and converted to single characters. Moreover, if the last character on the line is `\`, then the next line is treated as a continuation of the current line; the `\` and line terminator are simply discarded, and any leading whitespace characters on the continuation line are also discarded and are not part of the element string.

  As an example, each of the following four lines specifies the key `"Truth"` and the associated element value `"Beauty"`:

       Truth = Beauty
      	Truth:Beauty
       Truth			:Beauty

  As another example, the following three lines specify a single property:

       fruits				apple, banana, pear, \
                                        cantaloupe, watermelon, \
                                        kiwi, mango

  The key is `"fruits"` and the associated element is:

      "apple, banana, pear, cantaloupe, watermelon,kiwi, mango"

  Note that a space appears before each `\` so that a space will appear after each comma in the final result; the `\`, line terminator, and leading whitespace on the continuation line are merely discarded and are not replaced by one or more other characters.

  As a third example, the line:

      cheeses

  specifies that the key is `"cheeses"` and the associated element is the empty string.

  Parameters:
    `inStream` - the input stream.
  Throws:
    `IOException` - if an error occurred when reading from the input stream.

### save

    public void save(OutputStream out,
                     String header)

  Deprecated. This method does not throw an IOException if an I/O error occurs while saving the property list. As of the Java 2 platform v1.2, the preferred way to save a properties list is via the `store(OutputStream out, String header)` method.

  Calls the `store(OutputStream out, String header)` method and suppresses IOExceptions that were thrown.
  Parameters:
    `out` - an output stream.
    `header` - a description of the property list.
  Throws:
    `ClassCastException` - if this `Properties` object contains any keys or values that are not `Strings`.

### store

    public void store(OutputStream out,
                      String header)
               throws IOException

  Writes this property list (key and element pairs) in this `Properties` table to the output stream in a format suitable for loading into a `Properties` table using the `load` method. The stream is written using the ISO 8859-1 character encoding.

  Properties from the defaults table of this `Properties` table (if any) are not written out by this method.

  If the header argument is not null, then an ASCII `#` character, the header string, and a line separator are first written to the output stream. Thus, the `header` can serve as an identifying comment.

  Next, a comment line is always written, consisting of an ASCII `#` character, the current date and time (as if produced by the `toString` method of `Date` for the current time), and a line separator as generated by the Writer.

  Then every entry in this `Properties` table is written out, one per line. For each entry the key string is written, then an ASCII `=`, then the associated element string. Each character of the element string is examined to see whether it should be rendered as an escape sequence. The ASCII characters `\`, tab, newline, and carriage return are written as `\\`, `\t`, `\n`, and `\r`, respectively. Characters less than `\u0020` and characters greater than `\u007E` are written as `\u` xxxx for the appropriate hexadecimal value xxxx. Leading space characters, but not embedded or trailing space characters, are written with a preceding `\`. The key and value characters `#`, `!`, `=`, and `:` are written with a preceding slash to ensure that they are properly loaded.

  After the entries have been written, the output stream is flushed. The output stream remains open after this method returns.

  Parameters:
    `out` - an output stream.
    `header` - a description of the property list.
  Throws:
    `IOException` - if writing this property list to the specified output stream throws an `IOException`.
    `ClassCastException` - if this `Properties` object contains any keys or values that are not `Strings`.

### getProperty

    public String getProperty(String key)

  Searches for the property with the specified key in this property list. If the key is not found in this property list, the default property list, and its defaults, recursively, are then checked. The method returns `null` if the property is not found.
  Parameters:
    `key` - the property key.
  Returns:
    the value in this property list with the specified key value.
  See Also:
    `setProperty(java.lang.String, java.lang.String)`, `defaults`

### getProperty

    public String getProperty(String key,
                              String defaultValue)

  Searches for the property with the specified key in this property list. If the key is not found in this property list, the default property list, and its defaults, recursively, are then checked. The method returns the default value argument if the property is not found.
  Parameters:
    `key` - the hashtable key.
    `defaultValue` - a default value.
  Returns:
    the value in this property list with the specified key value.
  See Also:
    `setProperty(java.lang.String, java.lang.String)`, `defaults`

### propertyNames

    public Enumeration propertyNames()

  Returns an enumeration of all the keys in this property list, including the keys in the default property list.
  Returns:
    an enumeration of all the keys in this property list, including the keys in the default property list.
  See Also:
    `Enumeration`, `defaults`

### list

    public void list(PrintStream out)

  Prints this property list out to the specified output stream. This method is useful for debugging.
  Parameters:
    `out` - an output stream.

### list

    public void list(PrintWriter out)

  Prints this property list out to the specified output stream. This method is useful for debugging.
  Parameters:
    `out` - an output stream.
  Since:
    JDK1.1

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.